clear
clc
diary 'trust_region.txt'
excel_file = 'trust_region.xlsx';
n = 4;
Iters = 5;
bestFxArr = zeros(Iters,1);
bestXArr = zeros(Iters,n);
XLow = [1 2 3 4];
XHi = [2 3 4 5];
for i=1:Iters
  fprintf('Iter # %i -----------------------------------------------------\n', i);
  % use current values for XLow and XHi
  [bestX, bestFx] = scout4(@fx2, XLow, XHi, 0.1, 0.0001, 200, 250, 150, false, true, true);
  fprintf('%f ', bestX);
  fprintf(', bestFx = %20.18e\n', bestFx); 
  bestFxArr(i) = bestFx;
  bestXArr(i,:) = bestX;
  fprintf('\n----------------------------------------------------------------------\n\n');
end

fprintf('----------------------------------------------------------------------\n');
fprintf('XLow =[');
fprintf('%f ', XLow);
fprintf(']\n');
fprintf('XHi =[');
fprintf('%f ', XHi);
fprintf(']\n');fprintf('Min bestFx = %e\n', min(bestFxArr));
fprintf('Min bestFx = %20.18e\n', min(bestFxArr));
fprintf('Max bestFx = %20.18e\n', max(bestFxArr));
fprintf('Mean bestFx = %20.18e\n', mean(bestFxArr));
fprintf('Sdev bestFx = %20.18e\n', std(bestFxArr));
fprintf('Median bestFx = %20.18e\n', median(bestFxArr));

for i=1:n
    fprintf('Mean best X(%i) = %f\n', i, mean(bestXArr(:,i)));
end
Dx2 = XHi(1) - XLow(1);
dataArr = [Dx2  mean(bestFxArr)];
sMain = num2str(1);
sRange = strcat('A', sMain, ':B', sMain);
xlswrite(excel_file, dataArr, sRange);

row = 1;

for iMain=1:10
  
  % ------------------------------------- Decrease XLow
  XLow = XLow - 1;
  for i=1:Iters
    fprintf('Iter # %i -----------------------------------------------------\n', i);
    [bestX, bestFx] = scout4(@fx2, XLow, XHi, 0.1, 0.0001, 200, 250, 150, false, true, true);
    fprintf('%f ', bestX);
    fprintf(', bestFx = %20.18e\n', bestFx); 
    bestFxArr(i) = bestFx;
    bestXArr(i,:) = bestX;
    fprintf('\n----------------------------------------------------------------------\n\n');
  end

  fprintf('----------------------------------------------------------------------\n');
  fprintf('XLow =[');
  fprintf('%f ', XLow);
  fprintf(']\n');
  fprintf('XHi =[');
  fprintf('%f ', XHi);
  fprintf(']\n');fprintf('Min bestFx = %e\n', min(bestFxArr));
  fprintf('Min bestFx = %20.18e\n', min(bestFxArr));
  fprintf('Max bestFx = %20.18e\n', max(bestFxArr));
  fprintf('Mean bestFx = %20.18e\n', mean(bestFxArr));
  fprintf('Sdev bestFx = %20.18e\n', std(bestFxArr));
  fprintf('Median bestFx = %20.18e\n', median(bestFxArr));

  for i=1:n
      fprintf('Mean best X(%i) = %f\n', i, mean(bestXArr(:,i)));
  end  
  Dx2 = XHi(1) - XLow(1);
  dataArr = [Dx2  mean(bestFxArr)];
  row = row + 1;
  sMain = num2str(row);
  sRange = strcat('A', sMain, ':B', sMain);
  xlswrite(excel_file, dataArr, sRange);
  
  % ------------------------------------- Increase XHi
  XHi = XHi + 1;
  for i=1:Iters
    fprintf('Iter # %i -----------------------------------------------------\n', i);
    [bestX, bestFx] = scout4(@fx2, XLow, XHi, 0.1, 0.0001, 500, 250, 150, false, true, true);
    fprintf('%f ', bestX);
    fprintf(', bestFx = %20.18e\n', bestFx); 
    bestFxArr(i) = bestFx;
    bestXArr(i,:) = bestX;
    fprintf('\n----------------------------------------------------------------------\n\n');
  end

  fprintf('----------------------------------------------------------------------\n');
  fprintf('XLow =[');
  fprintf('%f ', XLow);
  fprintf(']\n');
  fprintf('XHi =[');
  fprintf('%f ', XHi);
  fprintf(']\n');fprintf('Min bestFx = %e\n', min(bestFxArr));
  fprintf('Max bestFx = %e\n', max(bestFxArr));
  fprintf('Mean bestFx = %e\n', mean(bestFxArr));
  fprintf('Sdev bestFx = %e\n', std(bestFxArr));
  for i=1:n
      fprintf('Mean best X(%i) = %f\n', i, mean(bestXArr(:,i)));
  end   
  Dx2 = XHi(1) - XLow(1);
  dataArr = [Dx2  mean(bestFxArr)];
  row = row + 1;
  sMain = num2str(row);
  sRange = strcat('A', sMain, ':B', sMain);
  xlswrite(excel_file, dataArr, sRange);  
end

diary off
