clear
clc
diary 'trust_region2.txt'
excel_file = 'trust_region1b.xlsx';

Iters = 5;
iMainMax = 50;
Xe = [1.2345 2.3456 3.4567 4.5678];
n=length(Xe);
m=n+1;
bestFxArr = zeros(Iters,1);
bestXArr = zeros(Iters,n);

for iMain=1:iMainMax
  % calculate random delta X vector
  Dx = 1 + iMain * rand(1,n);
  Dx2 = 2 * Dx;
  XLow = Xe - Dx;
  XHi = Xe + Dx;
  for i=1:Iters
    fprintf('Iter # %i -----------------------------------------------------\n', i);
    [bestX, bestFx] = scout(@fx2, XLow, XHi, 0.1, 0.0001, 200, 250, 150, false, true, true);
    fprintf('%f ', bestX);
    fprintf(', bestFx = %20.18e\n', bestFx); 
    bestFxArr(i) = bestFx;
    bestXArr(i,:) = bestX;
    fprintf('\n----------------------------------------------------------------------\n\n');
  end

  fprintf('----------------------------------------------------------------------\n');
  fprintf('XLow = [');
  fprintf('%f ', XLow);
  fprintf(']\n');
  fprintf('XHi = [');
  fprintf('%f ', XHi);
  fprintf('\nDx = [');
  fprintf('%f ', Dx2);
  fprintf(']\n');
  fprintf('Min bestFx = %20.18e\n', min(bestFxArr));
  fprintf('Max bestFx = %20.18e\n', max(bestFxArr));
  fprintf('Mean bestFx = %20.18e\n', mean(bestFxArr));
  fprintf('Sdev bestFx = %20.18e\n', std(bestFxArr));
  fprintf('Median bestFx = %20.18e\n', median(bestFxArr));
  dataArr = [Dx2  mean(bestFxArr)];
  sMain = num2str(iMain);
  sRange = strcat('A', sMain, ':E', sMain);
  xlswrite(excel_file, dataArr, sRange);
  for i=1:n
      fprintf('Mean best X(%i) = %f\n', i, mean(bestXArr(:,i)));
  end  
end

diary off
