clear
clc
diary 'exscout3_fx3.txt'
n = 4;
Iters = 40;
bestFxArr = zeros(Iters,1);
bestXArr = zeros(Iters,n);
fprintf('------------------- Using Semilog Decay of Walk Factors ----------------\n');
for i=1:Iters
  fprintf('Iter # %i -----------------------------------------------------\n', i);
  [bestX, bestFx] = exscout3(@fx3, zeros(1,n), 25+zeros(1,n), 0.1, 0.0001, 200, 250, 150, true, false, true);
  fprintf('%f ', bestX);
  fprintf(', bestFx = %20.18e\n', bestFx); 
  bestFxArr(i) = bestFx;
  bestXArr(i,:) = bestX;
  fprintf('\n----------------------------------------------------------------------\n\n');
end

fprintf('----------------------------------------------------------------------\n');
fprintf('Min bestFx = %20.18e\n', min(bestFxArr));
fprintf('Max bestFx = %20.18e\n', max(bestFxArr));
fprintf('Mean bestFx = %20.18e\n', mean(bestFxArr));
fprintf('Sdev bestFx = %20.18e\n', std(bestFxArr));
fprintf('Median bestFx = %20.18e\n', median(bestFxArr));
fprintf('Array of bestFx is:\n');
disp(bestFxArr);
for i=1:n
    fprintf('Mean best X(%i) = %f\n', i, mean(bestXArr(:,i)));
end
fprintf('\n------------------- Using Power Decay of Walk Factors ----------------\n');
for i=1:Iters
  fprintf('Iter # %i -----------------------------------------------------\n', i);
  [bestX, bestFx] = exscout3(@fx3, zeros(1,n), 25+zeros(1,n), 0.1, 0.0001, 200, 250, 150, false, false, true);
  fprintf('%f ', bestX);
  fprintf(', bestFx = %20.18e\n', bestFx); 
  bestFxArr(i) = bestFx;
  bestXArr(i,:) = bestX;
  fprintf('\n----------------------------------------------------------------------\n\n');
end

fprintf('----------------------------------------------------------------------\n');
fprintf('Min bestFx = %20.18e\n', min(bestFxArr));
fprintf('Max bestFx = %20.18e\n', max(bestFxArr));
fprintf('Mean bestFx = %20.18e\n', mean(bestFxArr));
fprintf('Sdev bestFx = %20.18e\n', std(bestFxArr));
fprintf('Median bestFx = %20.18e\n', median(bestFxArr));
fprintf('Array of bestFx is:\n');
disp(bestFxArr);
for i=1:n
    fprintf('Mean best X(%i) = %f\n', i, mean(bestXArr(:,i)));
end
diary off
